
<div class="container-fluid mt--5">
  <div class="row">
    <div class="col">
      <div class="card shadow">
        <div class="card-header border-0 flex-table">
          <div class="flex-buttons-title">
            <h3 class="mb-0 mr-5">Containers</h3>
            <a style="cursor: pointer;" (click)="startContainers()"><i class="material-icons click-icon-play" matTooltip="Start"> play_arrow </i></a>
            <a style="cursor: pointer;" (click)="stopContainers()"><i class="material-icons click-icon-stop" matTooltip="Stop"> stop </i></a>
            <a style="cursor: pointer;" (click)="resumeContainers()"><i class="material-icons click-icon-replay" matTooltip="Resume"> replay </i></a>
            <a style="cursor: pointer;" (click)="pauseContainers()"><i class="material-icons click-icon-pause" matTooltip="Pause"> pause </i></a>
            <a style="cursor: pointer;" (click)="restartContainers()"><i class="material-icons click-icon-restart" matTooltip="Restart"> skip_next </i></a>
            <a style="cursor: pointer;" (click)="prunContainers()"><i class="material-icons" style="color:cornflowerblue" matTooltip="Prune"> cleaning_services </i></a>

          </div>
          <div class="flex-buttons">
            <button class="btn btn-style" data-toggle="modal" data-target="#addContainer"> <i
                class="material-icons click-icon-add"> add </i>
              <p style="margin-top: 15px;">container</p>
            </button>
          </div>
        </div>
        <div class="table-responsive">
          <table class="table align-items-center table-flush">
            <thead class="thead-light">
              <tr>
                <th></th>
                <th scope="col">Name</th>
                <th scope="col">State</th>
                <th scope="col">Quick action</th>
                <th scope="col">Image</th>
                <th scope="col">Up Time</th>
                <th></th>
              </tr>
            </thead>
            <tbody *ngFor="let container of listContainers; let i = index;">
              <tr>
                  <td><mat-checkbox (click)="checked(container?.Id)"></mat-checkbox></td>

                <th scope="row">
                  <div class="media align-items-center">
                    <div class="media-body">
                      <span class="mb-0 text-sm">{{container?.Names[0]}}</span>
                    </div>
                  </div>
                </th>
                <td>
                  <span class="badge badge-dot mr-4 " [ngClass]="{'text-success': (container.State=== 'running'), 'text-danger':(container.State=== 'exited'),'text-warning':(container.State=== 'paused'), 'text-blue':(container.State=== 'created')   }">
                    <i  [ngClass]="{'bg-success': (container.State=== 'running'), 'bg-danger':(container.State=== 'exited'),'bg-warning':(container.State=== 'paused'),'bg-primary':(container.State=== 'created')  }"></i> {{container.State}}
                  </span>
                </td>
                <td>
                  <div class="actions">
                    <a href="javascript:void(0)">
                      <i matTooltip="logs" class="ni ni-single-copy-04 text-primary icon pt-3"></i>
                    </a>
                    <a href="javascript:void(0)">
                      <i matTooltip="stats" class="ni ni-chart-pie-35 text-red icon pt-3"></i>
                    </a>
                    <a  style="cursor: pointer;" (click)="getCurrentContainer(container.Id)" data-toggle="modal" data-target="#showContainer">
                      <i matTooltip="Info" class="ni ni-air-baloon text-green icon pt-3"></i>
                    </a>
                  </div>
                </td>
                <td>
                  {{container.Image}}
                </td>
                <td>
                  <div class="d-flex align-items-center">
                    <span class="mr-2">{{container.Status}}</span>
                  </div>
                </td>
                <td>
                  <div class="actions">
                    <a (click)="getIdContainer(container.Id)"  data-toggle="modal" data-target="#clearVolumes">
                        <i class="material-icons pt-3"  style="color:red" matTooltip="Delete">delete </i>
                    </a>
                  </div>
                </td>
              </tr>
              <!-- container data end-->
            </tbody>
          </table>
        </div>
      </div>
    </div>
  </div>
</div>
<div class="modal" id="addContainer">
  <div class="modal-dialog modal-xl">
    <div class="modal-content">

      <!-- Modal Header -->
      <div class="modal-header">
        <h4 class="modal-title">Deploy Container</h4>
        <button type="button" class="close" data-dismiss="modal">&times;</button>
      </div>

      <!-- Modal body -->
      <div class="modal-body">
        <form [formGroup]="containerForm">
          <div class="row">
            <div class="col-md-6 form-group">

              <mat-form-field appearance="outline" class="input-full">
                <mat-label>Name container</mat-label>
                <input formControlName="Name" matInput placeholder="Name container">
                <mat-error *ngIf="containerForm.hasError('required', 'Name')">Name of the container is <b>required</b>
                </mat-error>
              </mat-form-field>
            </div>
            <div class="col-md-6  form-group">
              <mat-form-field appearance="outline" class="input-full">
                <mat-label>Start container or not ?</mat-label>
                <mat-select (selectionChange)="setValueStart($event.value)">
                  <mat-option value="true">Yes</mat-option>
                  <mat-option value="false">No</mat-option>
                </mat-select>
                <mat-error *ngIf="containerForm.hasError('required', 'startContainer')">You have to <b>choose</b>
                </mat-error>
              </mat-form-field>
            </div>
            <div class="col-md-12">
              Image Configuration
              <hr>
            </div>
          </div>
          <div class="row">
            <div class="col-md-6  form-group">
              <mat-form-field appearance="outline" class="input-full">
                <mat-label>Image</mat-label>

                <input formControlName="Image" matInput placeholder="Image">
                <mat-error *ngIf="containerForm.hasError('required', 'Image')">Image is <b>required</b></mat-error>
              </mat-form-field>
            </div>
            <div class="col-md-6  form-group">
              <mat-form-field appearance="outline" class="input-full">
                <mat-label>Registry</mat-label>
                <mat-select (selectionChange)="setValue($event.value)">
                  <mat-option value="DockerHub">Docker Hub</mat-option>
                </mat-select>
                <mat-error *ngIf="containerForm.hasError('required', 'Registry')">Registry is <b>required</b>
                </mat-error>
              </mat-form-field>
            </div>
            <div class="col-md-12">
              Port Configuration
              <hr>
            </div>
          </div>
          <div class="row">
            <div class="col-md-12" style="display: flex;align-content: center;">
              <p class="mr-2"> Port Mapping </p><i (click)="addPort()" class="material-icons add-button text-blue">
                add_circle_outline </i>
            </div>
            <div class="col-md-12">
              <div class="row">
                <div class="col-md-12 border-style" formArrayName="Ports"
                  *ngFor="let port of containerForm.controls['Ports']['controls']; let i = index; ">
                  <div [formGroupName]="i">
                    <div class="row ">
                      <div class="col-md-4">
                        <mat-form-field appearance="outline" class="input-full">
                          <mat-label> Port Out</mat-label>
                          <input formControlName="PortIn" class="example-right-align" type="number" matInput
                            placeholder="Port In">
                          <mat-error *ngIf="port.hasError('required', 'PortIn')">Port In is <b>required</b>
                          </mat-error>
                          <mat-error *ngIf="port.hasError('min', 'PortIn') && !port.hasError('required', 'PortIn')"> Port In min is <b>0</b>
                          </mat-error>
                        </mat-form-field>
                      </div>
                      <div class="col-md-4">
                        <mat-form-field appearance="outline" class="input-full">
                          <mat-label>Port Out</mat-label>
                          <input formControlName="PortOut" class="example-right-align" type="number" matInput
                            placeholder="Port Out">
                          <mat-error *ngIf="port.hasError('required', 'PortOut')">Port Out is <b>required</b>
                          </mat-error>
                          <mat-error *ngIf="port.hasError('min', 'PortOut') && !port.hasError('required', 'PortOut')">Port Out min is <b>0</b>
                          </mat-error>
                        </mat-form-field>
                      </div>
                      <div class="col-md-3">
                        <mat-form-field appearance="outline" class="input-full">
                          <mat-label>Type</mat-label>
                          <input formControlName="Type" class="example-right-align" type="text" matInput
                            placeholder="Type">
                          <mat-error *ngIf="port.hasError('required', 'Type')">Type is <b>required</b>
                          </mat-error>
                        </mat-form-field>
                      </div>
                      <div class="col-md-1" style="margin-top: 1.5%;">
                          <i (click)="deletePort(i)" class="material-icons delete-button text-blue"> remove_circle_outline </i>
                      </div>
                    </div>
                  </div>
                </div>
              </div>
            </div>
          </div>

        </form>
      </div>

      <!-- Modal footer -->
      <div class="modal-footer">
        <button type="button" class="btn btn-danger" data-dismiss="modal">Close</button>
        <button type="button" class="btn btn-primary" data-dismiss="modal" (click)="createContainer()" [disabled]="!containerForm.valid">Deploy container</button>
      </div>

    </div>
  </div>
</div>
<div class="modal" id="clearVolumes">
  <div class="modal-dialog modal-xl">
    <div class="modal-content">

      <!-- Modal Header -->
      <div class="modal-header">
        <h4 class="modal-title">Clear Volumes ?</h4>
        <button type="button" class="close" data-dismiss="modal">&times;</button>
      </div>
      <!-- Modal footer -->
      <div class="modal-footer">
        <button type="button" class="btn btn-success" (click)="removeContainer(true)" data-dismiss="modal">Yes</button>
        <button type="button" class="btn btn-danger" (click)="removeContainer(false)" data-dismiss="modal">No</button>

      </div>

    </div>
  </div>
</div>
<div class="modal" id="showContainer">
  <div class="modal-dialog modal-xl">
    <div class="modal-content">

      <div class="modal-header">
        <h4 class="modal-title">{{currentContainer?.Name}}</h4>
        <button type="button" class="close" data-dismiss="modal">&times;</button>
      </div>

      <div class="modal-body">
        <div class="row">
          <div class="col-md-12">
            <b>State :</b> {{currentContainer?.State?.Status }}
          </div>
          <div class="col-md-12">
            <b>Image :</b> {{currentContainer?.Image }}
          </div>
          <div class="col-md-12">
            <b>Driver :</b> {{currentContainer?.Driver }}
          </div>
          <div class="col-md-12">
            <b>Platform :</b> {{currentContainer?.Platform }}
          </div>
          <div class="col-md-12" *ngIf="currentContainer?.Config?.Volumes === null" >
            <b>Linked volumes :</b> None
          </div>
          <div class="col-md-12">
            <b>Created At :</b> {{currentContainer?.Created | date }}
          </div>
        </div>
      </div>

      <div class="modal-footer">
        <button type="button" class="btn btn-danger" data-dismiss="modal">Close</button>
      </div>

    </div>
  </div>
</div>
